import pygame
import pyautogui
from math import floor  # 就只用到向下取整这个函数
import time
import random

sq = 25  # 格子宽，方便调试，不过经过实验我觉得25够好了
lc = [(10, 10, 200), (0, 255, 0), (255, 153, 0), (200, 200, 255), (160, 160,160), (100, 255, 100), (255, 253, 100), (200, 200, 255), (230, 230, 230)]
offset = [(1, 1), (1, 0), (1, -1), (0, 1), (0, -1), (-1, 1), (-1, 0), (-1, -1)] #位移量，1和2会用
pygame.init()
f1 = pygame.font.Font("freesansbold.ttf", sq)  # 创建一个格子大小的字体
bomb = pygame.image.load('爆炸.png')#炸弹图片

status = 3  # 游戏状态，我把一轮游戏中定为3，一轮游戏结束胜利定为2、失败为1，程序结束定为0
while status > 0:#大循环，包括每轮游戏和界面部分
    w, h = (int(pyautogui.prompt(title="扫雷", text="长", default="10")),int(pyautogui.prompt(title="扫雷", text="宽", default="10")))
    bomb_number = int(pyautogui.prompt(title="扫雷", text="雷数", default="10")) #获取自定义的长、宽、雷数
    lp = [] #位置列表
    ls = [] #状态列表
    lt = [] #类别列表
    for b in range(h):
        for a in range(w):
            lp.append((a, b))  # 遍历长、宽获取位置
            ls.append(0) #一开始每个格子没有特殊的状态，我把它记为0
            lt.append(0) #先假设每个格子都是数字0，占位
    c = [] #暂存雷在位置中的序列
    a = 0 #暂存已经随机添加的雷数
    while a < bomb_number:
        b = random.randint(0,w*h-1)#暂存一个随机的位置序列
        if b not in c:
            c.append(b)
            a += 1
    for a in c:
        lt[a] = 'bomb'#炸弹存入列表
    for a in lp:#替换数字格的数字
        if (lt[lp.index(a)] == 0):
            c = 0#暂存数字
            for b in offset:#遍历位移量
                d = (a[0]+b[0],a[1]+b[1])#位移后的位置
                if d in lp:
                    if (lt[lp.index(d)] == 'bomb'):  # 查询位移后的位置的格子类别是否是炸弹
                        c += 1                       # 如果是炸弹，数字加一
            lt[lp.index(a)] = c                      # 遍历完把原数字替换

    for a in [lp,lt,ls]:             ##
        for b in range(h):          ##
            d = []                 ########更好的打印效果，#
            for c in range(w):     #####方便调试，用完可删##
                d.append(a[b*w+c])  ##
            print(d,'\n')            ##
    pygame.display.quit()                              ######
    pygame.display.init()                              #初始#
    w1 = pygame.display.set_mode(size=(w*sq,h*sq))     #窗口#
    pygame.display.set_caption('扫雷')                 ######
    while status == 3:
        w1.fill((200, 200, 200))                                              #########
        for a in range(w+1):                                                  #填充背景#
            pygame.draw.line(w1,(180,180,180),(a*sq,0),(a*sq,h*sq),1)         #########
        for a in range(h+1):                                                  #画出线格#
            pygame.draw.line(w1, (180, 180, 180), (0,a*sq ), (w*sq, a*sq), 1) #########
        for a in lp:
            if (ls[lp.index(a)] == 1):    #被掀开
                pygame.draw.rect(w1, (220, 220, 220),((a[0]*sq, a[1]*sq), (sq, sq))) #格子填充背景
                if (lt[lp.index(a)] == 0):
                    pass                                                             #0没有效果
                elif (lt[lp.index(a)] == 'bomb'):
                    w1.blit(bomb,(a[0]*sq, a[1]*sq))                                 #炸弹则画出炸弹图像
                else:
                    w1.blit(f1.render(str(lt[lp.index(a)]), False, lc[lt[lp.index(a)]-1]), (a[0]*sq, a[1]*sq)) #画出数字格数字
            elif (ls[lp.index(a)] == 2):  #标记
                w1.blit(f1.render('m', False, (255, 0, 0, 1)),(a[0]*sq, a[1]*sq))    #红m
            elif (ls[lp.index(a)] == 3):  #怀疑
                w1.blit(f1.render('?', False, (0, 0, 255, 1)),(a[0]*sq, a[1]*sq))    #蓝问号
        pygame.display.flip()
        b = [0,0] #胜利条件：1标记出所有雷，2除了炸弹格以外所有格子翻开
        for a in range(len(lp)):
            if (lt[a] == 'bomb'):
                if (ls[a] == 1):  #失败条件：雷被翻开
                    status = 1    #修改状态为失败
                elif (ls[a] == 2):#标记
                    b[0] += 1     #列表第一项记录标记的雷数
            else:                 ##
                if (ls[a] == 1):  #数字格被翻开，列表第二项记录翻开的数字格数
                    b[1] += 1     ##
        if (b[0] == bomb_number or b[1] == w*h-bomb_number):#胜利条件
            status = 2
        e = pygame.event.wait()                   #等待一个事件
        if (e.type == pygame.QUIT):               #窗口关闭（点击叉叉）
            status = 0
        elif (e.type == pygame.MOUSEBUTTONDOWN):  #鼠标按下
            a,b = e.pos                           #获取点击格子坐标
            a = (floor(a/sq),floor(b/sq))         ##
            if (e.button == 1):                   #左键
                if (ls[lp.index(a)] == 0):        #|没有特殊状态（标记，怀疑，翻开）
                    ls[lp.index(a)] = 1           #|格子翻开
                    if (lt[lp.index(a)] == 0):    #|如果数字是0，翻开周围一圈
                        l0 = []                   # |l0为要遍历的数字0格子坐标的列表
                        l0.append(a)              # |加入第一个‘0’
                        while len(l0) > 0:        # |大遍历，一直循环直到没有0要翻开它周围一圈的格子
                            lA = l0               #  |lA暂时替代l0被遍历
                            for b in lA:          #  |_______________________________________________________
                                for c in offset:  #  /                 ######                           ######
                                    d = (b[0]+c[0], b[1]+c[1])         #遍历位移量 获取位移后位置及状态         #
                                    if d in lp:                        #如果状态不是被翻开 就翻开              #
                                        if (ls[lp.index(d)] == 0):     #且如果数字是0 加入l0列表准备下一轮遍历  #
                                            ls[lp.index(d)] = 1        #遍历完后 删除已经遍历完的那一个0        #
                                            if (lt[lp.index(d)] == 0): #等l0长度为0 没有0可以遍历 所有遍历结束  #
                                                l0.append(d)           ######                           ######
                                l0.pop(l0.index(b))# \________________________________________________________
            elif (e.button == 3):                 #右键   
                if (ls[lp.index(a)] == 0):        #|没有状态
                    ls[lp.index(a)] = 2           #|变为标记
                elif (ls[lp.index(a)] == 2):      #|标记状态
                    ls[lp.index(a)] = 3           #|变为疑惑
                elif (ls[lp.index(a)] == 3):      #|疑惑状态
                    ls[lp.index(a)] = 0           #|取消状态
    if (status == 2):                                       #胜利提示语
        text = '恭喜胜利'
    elif (status == 1):                                     #失败提示语
        text = '失败了，再接再厉'                            ##失败特效
        for a in range(len(lp)):                            #遍历画出所有雷
            if (lt[a] == 'bomb'):                           #可以加上等待一个随机秒数做出连锁反应的效果
                w1.blit(bomb,(lp[a][0]*sq,lp[a][1]*sq))     #也可以加上声音
        pygame.display.flip()                               ##
    a = pyautogui.confirm(text=text, title='扫雷', buttons=['再来一局', '退出游戏'])
    if (a == '再来一局'): #/显示一个消息提示框
        status = 3       #|再来一局
    else:                #|
        status = 0       #\退出游戏
pygame.quit()
#__        _        __     __           __
#\ \      | |      / /    |  |         |  |
# \ \    / / \    / /     |  |         |  |
#  \ \  / / \ \  / /      |  |         |  |
#   \ \/ /   \ \/ /       |  |______   |  |______
#    \__/     \__/        |_________|  |_________|
